using System;
using System.ComponentModel;
using System.ComponentModel.Design;
using System.Collections;
using System.Drawing;
using System.Workflow.ComponentModel.Compiler;
using System.Workflow.ComponentModel.Serialization;
using System.Workflow.ComponentModel;
using System.Workflow.ComponentModel.Design;
using System.Workflow.Runtime;
using System.Workflow.Activities;
using System.Workflow.Activities.Rules;
using System.Xml.Serialization;
using System.Xml;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WorkflowActions;

namespace AnnouncementWorkflow
{
	public sealed partial class Workflow1: SequentialWorkflowActivity
	{        

		public Workflow1()
		{
            //Instanciation d'un SPsite avec l'url de dfinie dans notre configuration, cd l'URL
            //du site o se trouve la liste (a pourrait donc tre n'importe quelle URL, ce n'est pas
            //restreint  un site ou  une site collection prcis)
           
			InitializeComponent();
		}

        public Guid workflowId = default(System.Guid);
        public Microsoft.SharePoint.Workflow.SPWorkflowActivationProperties workflowProperties = new Microsoft.SharePoint.Workflow.SPWorkflowActivationProperties();

        private void CreateAnnoncement_ExecuteCode(object sender, EventArgs e)
        {
            SPSite Site = null;
            SPWeb Web = null;
            SPList AnnouncementList = null;
            SPListItem NewItem = null;
            try
            {
                Site = new SPSite(AnnouncementWorkflow.Properties.Settings.Default.TargetSiteUrl);
                
                //Ouverture d'un SPWeb, cd un site
                Web = Site.OpenWeb();
                
                //0n pointe sur la liste d'annonces
                AnnouncementList = Web.Lists[AnnouncementWorkflow.Properties.Settings.Default.AnnouncementList];
                
                //On instancie un nouvel lment (nouvelle ligne pour la liste)
                NewItem = AnnouncementList.Items.Add();
                //On cre un petit message
                NewItem["Title"] = "Le document " + workflowProperties.Item["Title"] + " a t mis en ligne";
                //On cre un corps de message contenant l'URL du document
                NewItem["Body"] = "Vous pouvez consulter le document " + workflowProperties.Item["Title"] +
                    " <a href='" + workflowProperties.Item["EncodedAbsUrl"] + "'>ici</a>";
                //On met  jour l'lment de liste
                NewItem.Update();
                //On rcupre l'ID
                
                AnnouncementList.Update();
                Web.Update();               
                //On met un message dans l'historique.
                History.HistoryDescription = "Annonce " + NewItem.ID.ToString() + " cre avec succs";
               
            }
            catch(SPException Ex)
            {
                History.HistoryDescription = Ex.Message;
            }
            finally
            {
                if (Web != null) Web.Close();
                if (Site != null) Site.Close();
                NewItem = null;
                AnnouncementList = null;
                Web = null;
                Site = null;
            } 
           
        }

        

       

       
	}

}
